# Tripo H3.1 Text to 3D API

> ตัวสร้างเมชจากข้อความเป็น 3D พร้อมพรอมต์เชิงลบ ระดับคุณภาพเรขาคณิตและพื้นผิวที่แยกจากกัน และขีดจำกัดจำนวนหน้าที่สูงมาก

สร้างโมเดล 3D จากคำอธิบายข้อความความยาวไม่เกิน 1024 ตัวอักษร พร้อม `negative_prompt` ที่ไม่บังคับสำหรับระบุคุณลักษณะที่ต้องการหลีกเลี่ยง `face_limit` รับได้ตั้งแต่ 1,000 ถึง 2,000,000 หน้า `geometry_quality` และ `texture_quality` ตั้งเป็น standard หรือ detailed ได้แต่ละรายการ ตัวเลือกประกอบด้วยวัสดุ PBR โทโพโลยีสี่เหลี่ยม การปรับสเกลอัตโนมัติให้เป็นขนาดจริง และซีดแยกสำหรับเรขาคณิต ขั้นตอนแปลงข้อความเป็นรูปภาพ และเท็กซ์เจอร์

- Model id: `tripo3d/h3.1/text-to-3d`
- Made by: Tripo
- Category: Text to 3D
- Output: 3d
- Price per run: from $0.10 / run (cheapest run $0.10 (100 API credits))
- Run: `POST https://api.doitong.ru/v1/run/tripo3d/h3.1/text-to-3d`
- Quote: `POST https://api.doitong.ru/v1/quote/tripo3d/h3.1/text-to-3d`
- Docs page: https://doitong.com/th/developers/models/tripo3d/h3.1/text-to-3d

## Pricing

Price: **from $0.10 / run** (the lowest tier; the quote prices your exact input). Price per run: the input files are measured before the run (length, resolution, frame rate). The quote measures the same files and is exactly what the run charges.

The full example input below costs $0.20 = 200 API credits (1 run × $0.20).

Prices are the upstream price in USD, paid from the API balance in API credits (1000 API credits = 1 USD). `POST https://api.doitong.ru/v1/quote/tripo3d/h3.1/text-to-3d` with the same JSON body returns the exact price for that input; the quote is exactly what a run charges. Invalid input is never charged and failed or canceled requests are refunded automatically.

## Input parameters

| Parameter | Canonical name | Type | Required | Default | Allowed values / range | Description |
|---|---|---|---|---|---|---|
| `prompt` |  | string | yes |  | ≤ 1024 characters | คำอธิบายข้อความของวัตถุ 3D ที่ต้องการ จำกัดไม่เกิน 1024 อักขระ |
| `negative_prompt` |  | string \| null | no |  | ≤ 1024 characters | คำอธิบายคุณลักษณะที่ควรตัดออกจากโมเดลที่สร้าง |
| `face_limit` |  | integer \| null | no |  | 1,000 – 2,000,000 | เป้าหมายจำนวนหน้าเมชที่ระบุชัดเจนสำหรับการสร้างเมช ซึ่งจะแทนที่การเลือกจำนวนแบบปรับตามอัตโนมัติของโมเดลเมื่อมีการระบุค่า |
| `texture` |  | boolean | no | `true` |  | ควบคุมว่าโมเดลจะได้รับพื้นผิวที่สร้างขึ้นหรือไม่ |
| `pbr` |  | boolean | no | `true` |  | เปิดใช้วัสดุ PBR (Physically Based Rendering) ซึ่งจะเปิดใช้การสร้างพื้นผิวด้วยเมื่อเป็น true |
| `model_seed` |  | integer \| null | no |  |  | Seed ที่ใช้ทำให้การสร้างเรขาคณิตทำซ้ำได้ผลลัพธ์เดิม |
| `image_seed` |  | integer \| null | no |  |  | Seed ที่ใช้ในขั้นตอน text-to-image |
| `texture_seed` |  | integer \| null | no |  |  | Seed ที่ใช้ทำให้การสร้างพื้นผิวทำซ้ำได้ผลลัพธ์เดิม |
| `texture_quality` |  | enum (string) | no | `standard` | `standard`, `detailed` | การตั้งค่าคุณภาพพื้นผิว การเลือก 'detailed' จะเพิ่มความละเอียดพื้นผิว |
| `geometry_quality` |  | enum (string) | no | `standard` | `standard`, `detailed` | การตั้งค่าคุณภาพของเรขาคณิต |
| `auto_size` |  | boolean | no | `false` |  | การปรับสเกลอัตโนมัติเพื่อให้โมเดลมีขนาดจริงในหน่วยเมตร |
| `quad` |  | boolean | no | `false` |  | เลือกระหว่างหน้าแบบสามเหลี่ยมกับควอดที่มี 4 ด้านโดยเปิดใช้โทโพโลยีควอด สำหรับผลลัพธ์แบบควอด ระบบจะส่งคืนไฟล์ FBX เมื่อ Tripo จัดเตรียมข้อมูลเป็นไบต์ FBX |
| `enable_safety_checker` |  | boolean | no | `true` |  | สามารถผ่อนปรนการคัดกรองได้โดยตั้งค่าเป็น false หากผู้เรียกมีสิทธิ์ |

## Example input

Required parameters only:

```json
{
  "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field"
}
```

A fuller example:

```json
{
  "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field"
}
```

## Run it

Set `DOITONG_API_KEY` to a key from https://doitong.com/developers/dashboard#keys. `?wait=20` returns the finished request in the same call when it is ready within 20 seconds; otherwise poll `GET /requests/{id}` (it also accepts `?wait=`), or pass `webhook_url`.

### curl

```bash
# Run the model; wait up to 20 s for the finished result in the same call
curl -X POST "https://api.doitong.ru/v1/run/tripo3d/h3.1/text-to-3d?wait=20" \
  -H "Authorization: Bearer $DOITONG_API_KEY" \
  -H "Content-Type: application/json" \
  -d '{
    "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field"
  }'

# Still "queued" or "running"? Poll with the id from the response:
curl "https://api.doitong.ru/v1/requests/REQUEST_ID?wait=20" \
  -H "Authorization: Bearer $DOITONG_API_KEY"
```

### JavaScript

```javascript
const API = "https://api.doitong.ru/v1";
const headers = {
  "Authorization": "Bearer " + process.env.DOITONG_API_KEY,
  "Content-Type": "application/json",
};

// Run the model; wait up to 20 s for the finished result in the same call
let res = await fetch(API + "/run/tripo3d/h3.1/text-to-3d?wait=20", {
  method: "POST",
  headers,
  body: JSON.stringify({
    "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field"
  }),
});
let request = await res.json();
if (!res.ok) throw new Error(request.error.code + ": " + request.error.message);

// Not finished yet: long-poll until it is
while (request.status === "queued" || request.status === "running") {
  res = await fetch(API + "/requests/" + request.id + "?wait=20", { headers });
  request = await res.json();
}
if (request.status !== "succeeded") throw new Error(JSON.stringify(request.error));
console.log(request.outputs.map((o) => o.url), request.cost.credits + " API credits ($" + request.cost.usd + ")");
```

### Python

```python
import os
import requests

API = "https://api.doitong.ru/v1"
headers = {"Authorization": "Bearer " + os.environ["DOITONG_API_KEY"]}

payload = {
    "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field",
}

# Run the model; wait up to 20 s for the finished result in the same call
r = requests.post(API + "/run/tripo3d/h3.1/text-to-3d", params={"wait": 20}, json=payload, headers=headers)
request = r.json()
if not r.ok:
    raise RuntimeError(request["error"]["code"] + ": " + request["error"]["message"])

# Not finished yet: long-poll until it is
while request["status"] in ("queued", "running"):
    request = requests.get(API + "/requests/" + request["id"], params={"wait": 20}, headers=headers).json()
if request["status"] != "succeeded":
    raise RuntimeError(request["error"])
print([o["url"] for o in request["outputs"]], request["cost"]["credits"], "API credits", "$" + request["cost"]["usd"])
```

### MCP

The MCP server at `https://api.doitong.ru/v1/mcp` exposes the tools `search_models`, `get_model`, `quote`, `run`, `get_request`, `cancel_request`, `list_requests`, `create_upload` and `get_account`. A `run` call for this model:

```json
{
  "jsonrpc": "2.0",
  "id": 1,
  "method": "tools/call",
  "params": {
    "name": "run",
    "arguments": {
      "model_id": "tripo3d/h3.1/text-to-3d",
      "input": {
        "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field"
      },
      "wait_seconds": 20
    }
  }
}
```

## Response

Every call returns a request object. `status` is one of `queued`, `running`, `succeeded`, `failed`, `canceled`. `outputs` lists the generated files with URLs on our storage (kept forever, or 7 days with `?storage=temporary`; `storage` says which); `output` is the model's own result object with the same URLs.

```json
{
  "id": "req_8k2m4q7x1z9c3v5b6n0p2r4t",
  "object": "request",
  "model": "tripo3d/h3.1/text-to-3d",
  "status": "succeeded",
  "created_at": "2026-10-20T12:00:00Z",
  "started_at": "2026-10-20T12:00:02Z",
  "completed_at": "2026-10-20T12:00:09Z",
  "queue_position": null,
  "cost": {
    "credits": 200,
    "usd": "0.20",
    "charged": 200,
    "refunded": 0
  },
  "input": {
    "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field"
  },
  "output": {
    "model_mesh": {
      "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.jpeg",
      "content_type": "image/jpeg",
      "file_name": "0-output.jpeg",
      "file_size": 1843200
    },
    "model_urls": {
      "glb": {
        "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.jpeg",
        "content_type": "image/jpeg",
        "file_name": "0-output.jpeg",
        "file_size": 1843200
      },
      "fbx": {
        "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.jpeg",
        "content_type": "image/jpeg",
        "file_name": "0-output.jpeg",
        "file_size": 1843200
      },
      "base_model": {
        "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.jpeg",
        "content_type": "image/jpeg",
        "file_name": "0-output.jpeg",
        "file_size": 1843200
      },
      "pbr_model": {
        "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.jpeg",
        "content_type": "image/jpeg",
        "file_name": "0-output.jpeg",
        "file_size": 1843200
      }
    },
    "rendered_image": {
      "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.jpeg",
      "content_type": "image/jpeg",
      "file_name": "0-output.jpeg",
      "file_size": 1843200
    },
    "task_id": "string"
  },
  "outputs": [
    {
      "type": "file",
      "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.jpeg",
      "content_type": "image/jpeg",
      "file_size": 1843200,
      "stored": true
    }
  ],
  "error": null,
  "metrics": {
    "inference_seconds": 6.8
  },
  "urls": {
    "self": "https://api.doitong.ru/v1/requests/req_8k2m4q7x1z9c3v5b6n0p2r4t",
    "cancel": "https://api.doitong.ru/v1/requests/req_8k2m4q7x1z9c3v5b6n0p2r4t/cancel"
  }
}
```

### Output fields (`output`)

| Field | Type | Description |
|---|---|---|
| `model_mesh` | object {url, content_type, file_name, file_size} | ไฟล์ GLB หรือ FBX ที่มีโมเดล 3D ที่สร้างขึ้น โดยรูปแบบจะขึ้นอยู่กับสิ่งที่ Tripo สร้าง |
| `model_urls` | object {glb, fbx, base_model, pbr_model} | URL ที่ชี้ไปยังเวอร์ชันอื่นของโมเดล 3D |
| `rendered_image` | object {url, content_type, file_name, file_size} \| null | ตัวอย่างภาพเรนเดอร์ที่แสดงโมเดล 3D ที่สร้างขึ้น |
| `task_id` | string \| null | รหัสงาน Tripo ที่นำกลับมาใช้ใหม่ได้ ซึ่งระบุโมเดลที่สร้างขึ้นสำหรับ rig หรือ rig-check ทำให้ดำเนินการเหล่านั้นได้โดยไม่ต้องอัปโหลดโมเดลอีกครั้ง |

## Related models

- [Tripo H3.1 Image to 3D](https://doitong.com/developers/models/tripo3d/h3.1/image-to-3d.md) (`tripo3d/h3.1/image-to-3d`): from $0.20 / run
- [Tripo H3.1 Multiview to 3D](https://doitong.com/developers/models/tripo3d/h3.1/multiview-to-3d.md) (`tripo3d/h3.1/multiview-to-3d`): from $0.20 / run
- [Tripo P1 Text to 3D](https://doitong.com/developers/models/tripo3d/p1/text-to-3d.md) (`tripo3d/p1/text-to-3d`): $1.10 / run
- [Tripo P2 Text to 3D](https://doitong.com/developers/models/tripo3d/p2/text-to-3d.md) (`tripo3d/p2/text-to-3d`): from $1.00 / run
- [Hunyuan 3d](https://doitong.com/developers/models/hunyuan-3d/v3.1/rapid/text-to-3d.md) (`hunyuan-3d/v3.1/rapid/text-to-3d`): from $0.225 / request
- [Hunyuan 3D Pro Text to 3D](https://doitong.com/developers/models/hunyuan-3d/v3.1/pro/text-to-3d.md) (`hunyuan-3d/v3.1/pro/text-to-3d`): $0.375 / run
- [Hunyuan Motion \[0.46B\]](https://doitong.com/developers/models/hunyuan-motion/fast.md) (`hunyuan-motion/fast`): $0.06 / request
- [Hunyuan Motion \[1B\]](https://doitong.com/developers/models/hunyuan-motion.md) (`hunyuan-motion`): $0.08 / request

## Links

- HTML page: https://doitong.com/developers/models/tripo3d/h3.1/text-to-3d
- All models and guides for AI agents: https://doitong.com/developers/llms.txt
- OpenAPI 3.1 with this model's typed request body: https://doitong.com/developers/openapi.json?model=tripo3d/h3.1/text-to-3d
- Errors: https://doitong.com/developers/docs/errors
- Model details as JSON: https://api.doitong.ru/v1/models/tripo3d/h3.1/text-to-3d
